package de.snailshell.consensus.demo.actions;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import de.snailshell.consensus.demo.Constants;
import de.uka.ipd.consensus.foundation.ontology.OntologyManager;
import de.uka.ipd.consensus.foundation.schema.Attribute;
import de.uka.ipd.consensus.foundation.schema.Topic;
import de.uka.ipd.consensus.foundation.schema.User;

/**
 * @author Thomas Much
 * @version 2006-06-14
 */
public class CreateAttributeAction extends BasisAction {

	public ActionForward execute(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		if (!isUserLoggedOn(request)) {
			return mapping.findForward( Constants.MAPPING_FAILURE );
		}

		String topicid    = ((DynaActionForm)form).getString("topicid");
		String attrname   = ((DynaActionForm)form).getString("attrname");
		String attrvalue  = ((DynaActionForm)form).getString("attrvalue");
		String attrtypeid = ((DynaActionForm)form).getString("attrtypeid");
		
		OntologyManager om = this.getOntologyManager();
		
		User user = this.getUser(request);
		
		Topic t = om.getQueryEngine().getTopicById( user, topicid );
		
		if ((attrname != null) && (attrname.length() > 0)) {
			Topic type = om.getQueryEngine().getTopicById( user, attrtypeid );
			
			Attribute a = om.createAttribute( user, null, attrname, attrvalue, type );

			t.addAttribute( user, a );
		}

		request.setAttribute( Constants.REQUEST_ATTR_TOPIC, t );

		return mapping.findForward( Constants.MAPPING_SUCCESS );
	}
}
